# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::EntitySearch::V1_0
  module Models
    #
    # Defines the top-level object that the response includes when the request
    # succeeds.
    #
    class SearchResponse < Response

      include MsRestAzure


      def initialize
        @_type = "SearchResponse"
      end

      attr_accessor :_type

      # @return [QueryContext] An object that contains the query string that
      # Bing used for the request. This object contains the query string as
      # entered by the user. It may also contain an altered query string that
      # Bing used for the query if the query string contained a spelling
      # mistake.
      attr_accessor :query_context

      # @return [Entities] A list of entities that are relevant to the search
      # query.
      attr_accessor :entities

      # @return [Places] A list of local entities such as restaurants or hotels
      # that are relevant to the query.
      attr_accessor :places


      #
      # Mapper for SearchResponse class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SearchResponse',
          type: {
            name: 'Composite',
            class_name: 'SearchResponse',
            model_properties: {
              _type: {
                client_side_validation: true,
                required: true,
                serialized_name: '_type',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              contractual_rules: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'contractualRules',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ContractualRulesContractualRuleElementType',
                      type: {
                        name: 'Composite',
                        polymorphic_discriminator: '_type',
                        uber_parent: 'ContractualRulesContractualRule',
                        class_name: 'ContractualRulesContractualRule'
                      }
                  }
                }
              },
              web_search_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'webSearchUrl',
                type: {
                  name: 'String'
                }
              },
              query_context: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'queryContext',
                type: {
                  name: 'Composite',
                  class_name: 'QueryContext'
                }
              },
              entities: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'entities',
                type: {
                  name: 'Composite',
                  class_name: 'Entities'
                }
              },
              places: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'places',
                type: {
                  name: 'Composite',
                  class_name: 'Places'
                }
              }
            }
          }
        }
      end
    end
  end
end
